package gui.drawing;

import java.awt.Dimension;
import java.awt.Point;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JComboBox;
import javax.swing.JDialog;
import javax.swing.JPanel;

import geometry.PointList;
import helper.TypeConverter;
import net.miginfocom.swing.MigLayout;

@SuppressWarnings("serial")
public class PopUpPointList extends JDialog {
		private PopUpPointList popUp;
		private Painter painter;
		private PointList pointList;

		private JComboBox<String> cobTypes;

		public PopUpPointList(Point point, PointList pointList, Painter painter) {
			super();

			setTitle("Set Type");
			setPainter(painter);
			setPointList(pointList);

			createWidgets();
			addWidgets();
			addListener();

			setPopUp(this);

			setModal(true);
			setLocation(point);
			setResizable(false);
			pack();
			setVisible(true);
		}

		private void addListener() {
			cobTypes.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent arg0) {
					pointList.setType(TypeConverter.stringToType(cobTypes.getSelectedItem().toString()));
					popUp.dispose();
				}
			});
		}

		private void addWidgets() {
			MigLayout layout = new MigLayout();
			setLayout(layout);

			add(cobTypes);
		}

		private void createWidgets() {
			setContentPane(new JPanel());
			
			@SuppressWarnings("static-access")
			String[] regionTypesString = painter.getRegionManager().getRegionNames();
			
			cobTypes = new JComboBox<String>(regionTypesString) {
				@Override
				public Dimension getMaximumSize() {
					Dimension max = super.getMaximumSize();
					max.height = getPreferredSize().height;
					return max;
				}
			};
		}

		public PointList getPointList() {
			return pointList;
		}

		public void setPointList(PointList pointList) {
			this.pointList = pointList;
		}

		public PopUpPointList getPopUp() {
			return popUp;
		}

		public void setPopUp(PopUpPointList popUp) {
			this.popUp = popUp;
		}

		public Painter getPainter() {
			return painter;
		}

		public void setPainter(Painter painter) {
			this.painter = painter;
		}
	}