package gui.postProcessing;

import java.awt.Dimension;
import java.awt.Point;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JComboBox;
import javax.swing.JDialog;
import javax.swing.JPanel;

import helper.TypeConverter;
import net.miginfocom.swing.MigLayout;
import regions.RegionManager;
import regions.type.RegionType;
import segmentation.result.ResultRegion;
import segmentation.result.SegmentationResult;

@SuppressWarnings("serial")
public class DiaSwitchType extends JDialog {

	private DiaSwitchType popUp;
	private JComboBox<String> cobTypes;

	public DiaSwitchType(Point point, ResultRegion region, SegmentationResult segResult, PainterPP painter) {
		super();

		setTitle("Set Type");

		createWidgets();
		addWidgets();
		addListener(region, segResult, painter);

		setPopUp(this);

		setModal(true);
		setLocation(point);
		setResizable(false);
		pack();
		setVisible(true);
	}

	private void addListener(final ResultRegion region, final SegmentationResult segResult, final PainterPP painter) {
		cobTypes.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				RegionType type = TypeConverter.stringToType(cobTypes.getSelectedItem().toString());
				region.setType(type);
				
				if(type.equals(RegionType.image)) {
					for(ResultRegion roRegion : segResult.getReadingOrder()) {
						if(roRegion.getPoints().equals(region.getPoints())) {
							segResult.getReadingOrder().remove(roRegion);
							break;
						}
					}
				}
				
				painter.setActivePosition(null);
				painter.calcImage();
				painter.getPanel().repaintAll();

				popUp.dispose();
			}
		});
	}

	private void addWidgets() {
		MigLayout layout = new MigLayout();
		setLayout(layout);

		add(cobTypes);
	}

	private void createWidgets() {
		setContentPane(new JPanel());

		String[] regionTypesString = RegionManager.getRegionNames();

		cobTypes = new JComboBox<String>(regionTypesString) {
			@Override
			public Dimension getMaximumSize() {
				Dimension max = super.getMaximumSize();
				max.height = getPreferredSize().height;
				return max;
			}
		};
	}

	public DiaSwitchType getPopUp() {
		return popUp;
	}

	public void setPopUp(DiaSwitchType popUp) {
		this.popUp = popUp;
	}
}