package gui.postProcessing;

import java.awt.Graphics;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.event.MouseMotionAdapter;
import java.awt.image.BufferedImage;

import javax.swing.JPanel;

import org.opencv.core.Mat;

import segmentation.result.SegmentationResult;

@SuppressWarnings("serial")
public class ResultsPanel extends JPanel {

	private BufferedImage imageBI;
	private Mat imageMat;
	
	private Mat original;

	private SegmentationResult segmentationResult;
	
	private PainterPP painter;

	public ResultsPanel(Mat original, Mat resized, SegmentationResult segmentationResult) {
		setOriginal(original);
		setSegmentationResult(segmentationResult);

		setOpaque(false);
		addListeners();
		
		setPainter(new PainterPP(this, segmentationResult, resized.height()));
		painter.calcImage();
	}
	
	public void addListeners() {
		addMouseListener(new MouseAdapter() {
			public void mousePressed(MouseEvent e) {
				painter.handleMousePressed(e);
				repaint();
			}

			public void mouseReleased(MouseEvent e) {
			}
		});

		addMouseMotionListener(new MouseMotionAdapter() {
			public void mouseDragged(MouseEvent e) {
			}

			public void mouseMoved(MouseEvent e) {
			}
		});
	}

	public void repaintAll() {
		repaint();
	}

	public void paint(Graphics g) {
		painter.setG(g);
		super.paint(g);
		painter.paint(original);
	}

	public SegmentationResult getSegmentationResult() {
		return segmentationResult;
	}

	public void setSegmentationResult(SegmentationResult segmentationResult) {
		this.segmentationResult = segmentationResult;
	}

	public BufferedImage getImageBI() {
		return imageBI;
	}

	public void setImageBI(BufferedImage imageBI) {
		this.imageBI = imageBI;
	}

	public Mat getImageMat() {
		return imageMat;
	}

	public void setImageMat(Mat imageMat) {
		this.imageMat = imageMat;
	}

	public Mat getOriginal() {
		return original;
	}

	public void setOriginal(Mat original) {
		this.original = original;
	}

	public PainterPP getPainter() {
		return painter;
	}

	public void setPainter(PainterPP painter) {
		this.painter = painter;
	}	
}