package gui.readingOrder;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JPanel;

import dataManagement.Page;
import net.miginfocom.swing.MigLayout;

@SuppressWarnings("serial")
public class ReadingOrderGui extends JDialog {

	private ReadingOrderPainter painter;
	private JButton btnSaveAndExit;
	private JButton btnNewRO;
	private JPanel panel;

	private Page page;

	public ReadingOrderGui(Page page) {
		super(new JFrame(), "Assign Reading Order");
		
		setPage(page);
		page.getSegmentationResult().applyScaleCorrection(page.getOriginal(), page.getResized());		

		createWidgets();
		addWidgets();
		addListener();

		pack();
		setLocationRelativeTo(null);
		setResizable(false);
		setModal(true);
	}

	public void addListener() {
		btnNewRO.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				painter.initNewRO();
			}
		});

		btnSaveAndExit.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				dispose();
			}
		});
	}

	public void addWidgets() {
		add(panel);

		MigLayout layout = new MigLayout();
		panel.setLayout(layout);

		panel.add(painter, "wrap");
		panel.add(btnSaveAndExit, "split, sg 1, center");
		panel.add(btnNewRO, "sg 1, center");
	}

	public void createWidgets() {
		painter = new ReadingOrderPainter(page);
		btnSaveAndExit = new JButton("Save And Exit");
		btnNewRO = new JButton("New Reading Order");
		panel = new JPanel();
	}

	public Page getPage() {
		return page;
	}

	public void setPage(Page page) {
		this.page = page;
	}
}