package importExport;

import java.io.File;

import org.opencv.highgui.Highgui;

import dataManagement.Page;

public class ToAletheia {

	private static String aletheiaFolder;

	public static void saveForAletheia(Page page, String outputFolder) {
		if (aletheiaFolder == null) {
			initFolder(outputFolder);
		}

		if (page.getSegmentationResult() != null) {
			PageXMLWriterOld.writePageXML(page, aletheiaFolder, false);
		} else {
			System.out.println("No Segmentation Result present! Just copying Image!");
		}
		
		Highgui.imwrite(aletheiaFolder + page.getIdentifier() + ".tif", page.getOriginal());
	}

	private static void initFolder(String outputFolder) {
		aletheiaFolder = outputFolder;

		if (!aletheiaFolder.endsWith(File.separator)) {
			aletheiaFolder += File.separator;
		}

		aletheiaFolder += "Later" + File.separator;

		new File(aletheiaFolder).mkdirs();
	}
}