package linePP;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.filechooser.FileNameExtensionFilter;

import linePP.calc.LinePP;
import net.miginfocom.swing.MigLayout;

@SuppressWarnings("serial")
public class DiaCalcAll extends JDialog {

	private String inputFolder;
	private File[] selectedFiles;

	private JButton btnSelectFiles;
	private JButton btnCalcLines;
	private JFileChooser fileChooser;

	public DiaCalcAll(String inputFolder) {
		super(new JFrame(), "Calc Lines");

		setInputFolder(inputFolder);

		createWidgets();
		addWidgets();
		addListener();

		pack();
		setLocationRelativeTo(null);
		setResizable(false);
		setModal(true);
		setVisible(true);
	}

	private void selectFiles() {
		int returnVal = fileChooser.showOpenDialog(null);
		File[] selectedFiles = new File[0];
		
		if (returnVal == JFileChooser.APPROVE_OPTION) {
			selectedFiles = fileChooser.getSelectedFiles();
		}
		setSelectedFiles(selectedFiles);
	}

	public void addListener() {
		btnSelectFiles.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				selectFiles();
			}
		});
		
		btnCalcLines.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				int cnt = 0;
				
				for(File file : selectedFiles) {
					LinePP linePP = new LinePP(inputFolder);
					linePP.calcLines(file);
					
					System.out.println("\nFile " + ++cnt +  "/" + selectedFiles.length + " done!\n");
					System.gc();
				}
			}
		});
	}

	public void addWidgets() {
		MigLayout layout = new MigLayout();
		setLayout(layout);

		add(btnSelectFiles, "sg 1, wrap");
		add(btnCalcLines, "sg 1");
	}

	public void createWidgets() {
		setContentPane(new JPanel());

		btnSelectFiles = new JButton("Select Files");
		btnCalcLines = new JButton("Calc Lines");
		btnCalcLines.setEnabled(false);

		fileChooser = new JFileChooser(inputFolder + File.separator + "SegmentXMLs");
		fileChooser.setFileSelectionMode(JFileChooser.FILES_ONLY);
		fileChooser.setMultiSelectionEnabled(true);
		fileChooser.setFileFilter(new FileNameExtensionFilter("PageXML", "xml"));
	}

	public String getInputFolder() {
		return inputFolder;
	}

	public void setInputFolder(String inputFolder) {
		this.inputFolder = inputFolder;
	}

	public File[] getSelectedFiles() {
		return selectedFiles;
	}

	public void setSelectedFiles(File[] selectedFiles) {
		if (selectedFiles.length > 0) {
			this.selectedFiles = selectedFiles;
			btnCalcLines.setEnabled(true);
		} else {
			btnCalcLines.setEnabled(false);
		}
	}
}