package linePP.auto;

import java.util.ArrayList;

import linePP.data.Line;
import linePP.data.LinePage;
import linePP.data.Segment;
import linePP.drawing.Cutter;
import regions.type.RegionType;

public class PostProc {

	public static void postProcess(LinePage linePage) {
		boolean done = false;

		while (!done) {
			done = splitHighLines(linePage);
		}

		done = false;

		while (!done) {
			done = Merger.mergeLines(linePage);
		}
	}

	private static void mergeHighLines(LinePage linePage, Segment segment, int index) {
		Line line = segment.getLines().get(index);
		int i = index;

		boolean keepSearching = true;
		ArrayList<Line> toMerge = new ArrayList<Line>();
		toMerge.add(line);

		while (keepSearching) {
			if (i < segment.getLines().size() - 1) {
				i++;
				if (segment.getLines().get(i).getLineType().equals(LineType.HIGH)) {
					toMerge.add(segment.getLines().get(i));
				}
			} else {
				keepSearching = false;
			}
		}

		Line aboveLine = null;
		Line belowLine = null;

		if (index > 0) {
			aboveLine = segment.getLines().get(index - 1);
		}

		if (index < segment.getLines().size() - 1) {
			belowLine = segment.getLines().get(index + 1);
		}

		Merger.merge(toMerge, segment, linePage, aboveLine, belowLine, RegionType.heading);
	}

	public static boolean splitHighLines(LinePage linePage) {
		for (Segment segment : linePage.getSegments()) {
			if (!segment.getType().equals(RegionType.heading)) {
				for (int i = 0; i < segment.getLines().size(); i++) {
					Line line = segment.getLines().get(i);

					if (line.getLineType().equals(LineType.HIGH)) {
						line.setLineType(LineType.NORMAL);
						if (segment.getLines().size() == 1) {
							segment.setType(RegionType.heading);
						} else if (i == segment.getLines().size() - 1) {
							ArrayList<Segment> newSegments = Cutter.performCut(linePage, segment,
									segment.getLines().get(i - 1), false);

							for (Segment newSegment : newSegments) {
								if (newSegment.getLines().contains(line)) {
									newSegment.setType(RegionType.heading);
								}
							}
						} else {
							if (segment.getLines().get(i + 1).getLineType().equals(LineType.HIGH)) {
								mergeHighLines(linePage, segment, i);
							} else {
								Cutter.performCut(linePage, segment, line, true);
							}
						}
						return false;
					}
				}
			}
		}

		return true;
	}
}