package linePP.auto;

import java.util.ArrayList;
import java.util.Collections;

import regions.type.RegionType;
import segmentation.result.ResultRegion;

public class ReadingOrder {

	@SuppressWarnings("unchecked")
	public static ArrayList<ResultRegion> assignReadingOrder954(ArrayList<ResultRegion> leftRegions,
			ArrayList<ResultRegion> rightRegions) {
		ArrayList<ResultRegion> orderedRegions = new ArrayList<ResultRegion>();
		Collections.sort(leftRegions);
		Collections.sort(rightRegions);

		int startIndexLeft = 0;
		int startIndexRight = 0;

		if (leftRegions.size() == 0 && rightRegions.size() == 0) {
			return orderedRegions;
		}

		if (leftRegions.size() == 0) {
			return rightRegions;
		}

		if (rightRegions.size() == 0) {
			return leftRegions;
		}

		if (leftRegions.get(0).getType().equals(RegionType.heading)
				|| leftRegions.get(0).getType().equals(RegionType.page_number)) {
			orderedRegions.add(leftRegions.get(0));

			startIndexLeft++;
		}

		if (rightRegions.get(0).getType().equals(RegionType.heading)
				|| rightRegions.get(0).getType().equals(RegionType.page_number)) {
			orderedRegions.add(rightRegions.get(0));
			startIndexRight = 1;
		}

		orderedRegions.addAll(leftRegions.subList(startIndexLeft, leftRegions.size()));
		orderedRegions.addAll(rightRegions.subList(startIndexRight, rightRegions.size()));

		return orderedRegions;
	}

	@SuppressWarnings("unchecked")
	public static ArrayList<ResultRegion> assignReadingOrder(ArrayList<ResultRegion> leftRegions,
			ArrayList<ResultRegion> rightRegions) {
		ArrayList<ResultRegion> orderedRegions = new ArrayList<ResultRegion>();
		Collections.sort(leftRegions);
		Collections.sort(rightRegions);

		int startIndex = 0;

		if (leftRegions.size() == 0 && rightRegions.size() == 0) {
			return orderedRegions;
		}

		if (leftRegions.size() == 0) {
			return rightRegions;
		}

		if (rightRegions.size() == 0) {
			return leftRegions;
		}

		if (leftRegions.get(0).getType().equals(RegionType.heading)
				&& rightRegions.get(0).getType().equals(RegionType.heading)) {
			orderedRegions.add(leftRegions.get(0));
			orderedRegions.add(rightRegions.get(0));
			startIndex = 1;
		}

		orderedRegions.addAll(leftRegions.subList(startIndex, leftRegions.size()));
		orderedRegions.addAll(rightRegions.subList(startIndex, rightRegions.size()));

		return orderedRegions;
	}
}