package linePP.calc;

import java.util.ArrayList;

import org.opencv.core.Mat;

import segmentation.result.ResultRegion;

public class Page {

	private String imageFilename;
	private Mat matImage;
	private ArrayList<Segment> segments;

	public Page(String imageFilename, ArrayList<Segment> segments) {
		setImageFilename(imageFilename.substring(0, imageFilename.lastIndexOf(".")));
		setSegments(segments);
	}

	public Page(dataManagement.Page resultPage) {
		setImageFilename(resultPage.getFileName());

		if (resultPage.getSegmentationResult() != null) {
			ArrayList<Segment> segments = new ArrayList<Segment>();

			for (ResultRegion region : resultPage.getSegmentationResult().getRegions()) {
				Segment segment = new Segment(region.getType().toString(),
						region.scalePointsSimple(resultPage.getSegmentationResult().getScaleFactor()));
				segments.add(segment);
			}

			setSegments(segments);
		} else {
			System.out.println("Segmentation Result NULL!");
			setSegments(new ArrayList<Segment>());
		}
	}

	public String getImageFilename() {
		return imageFilename;
	}

	public void setImageFilename(String imageFilename) {
		this.imageFilename = imageFilename;
	}

	public Mat getMatImage() {
		return matImage;
	}

	public void setMatImage(Mat matImage) {
		this.matImage = matImage;
	}

	public ArrayList<Segment> getSegments() {
		return segments;
	}

	public void setSegments(ArrayList<Segment> segments) {
		this.segments = segments;
	}
}