package linePP.calc;

import org.opencv.core.Mat;
import org.opencv.core.MatOfPoint;

import linePP.helper.ImageProcessor;

public class Segment {

	private String type;
	private MatOfPoint polygon;
	private boolean isBigEnough;
	private double angle;
	private Mat segmentImage;

	public Segment(String type, MatOfPoint polygon) {
		setType(type);
		setPolygon(polygon);
	}

	public void clean() {
		ImageProcessor.releaseAll(segmentImage, polygon);
	}

	public String getType() {
		return type;
	}

	public void setType(String type) {
		this.type = type;
	}

	public MatOfPoint getPolygon() {
		return polygon;
	}

	public void setPolygon(MatOfPoint polygon) {
		this.polygon = polygon;
	}

	public boolean isBigEnough() {
		return isBigEnough;
	}

	public void setBigEnough(boolean isBigEnough) {
		this.isBigEnough = isBigEnough;
	}

	public double getAngle() {
		return angle;
	}

	public void setAngle(double angle) {
		this.angle = angle;
	}

	public Mat getSegmentImage() {
		return segmentImage;
	}

	public void setSegmentImage(Mat segmentImage) {
		this.segmentImage = segmentImage;
	}
}