package linePP.data;

import org.opencv.core.MatOfPoint;
import org.opencv.core.Point;

import linePP.auto.LineType;
import regions.type.RegionType;

public class Line {

	private MatOfPoint linePoints;
	private Line originalLine;
	private Line resizedLine;
	private RegionType type;
	private Polygon polygon;
	private boolean isActive;

	private Point topLeft;
	private Point topRight;
	private Point bottomRight;
	private Point bottomLeft;

	private LineType lineType;

	public Line(MatOfPoint linePoints, Line originalLine, RegionType type) {
		setLinePoints(linePoints);
		setOriginalLine(originalLine);
		setType(type);
		setLineType(LineType.NORMAL);

		setTopLeft(linePoints.toArray()[0]);
		setTopRight(linePoints.toArray()[1]);
		setBottomRight(linePoints.toArray()[2]);
		setBottomLeft(linePoints.toArray()[3]);
	}

	public MatOfPoint getLinePoints() {
		return linePoints;
	}

	public void setLinePoints(MatOfPoint linePoints) {
		this.linePoints = linePoints;
	}

	public Line getOriginalLine() {
		return originalLine;
	}

	public void setOriginalLine(Line originalLine) {
		this.originalLine = originalLine;
	}

	public Line getResizedLine() {
		return resizedLine;
	}

	public void setResizedLine(Line resizedLine) {
		resizedLine.setLineType(this.lineType);
		
		this.resizedLine = resizedLine;
	}

	public RegionType getType() {
		return type;
	}

	public void setType(RegionType type) {
		this.type = type;
	}

	public boolean isActive() {
		return isActive;
	}

	public void setActive(boolean isActive) {
		this.isActive = isActive;
	}

	public Polygon getPolygon() {
		return polygon;
	}

	public void setPolygon(Polygon polygon) {
		this.polygon = polygon;
	}

	public Point getTopLeft() {
		return topLeft;
	}

	public void setTopLeft(Point topLeft) {
		this.topLeft = topLeft;
	}

	public Point getBottomRight() {
		return bottomRight;
	}

	public void setBottomRight(Point bottomRight) {
		this.bottomRight = bottomRight;
	}

	public Point getTopRight() {
		return topRight;
	}

	public void setTopRight(Point topRight) {
		this.topRight = topRight;
	}

	public Point getBottomLeft() {
		return bottomLeft;
	}

	public void setBottomLeft(Point bottomLeft) {
		this.bottomLeft = bottomLeft;
	}

	public LineType getLineType() {
		return lineType;
	}

	public void setLineType(LineType lineType) {
		if(resizedLine != null) {
			resizedLine.setLineType(this.lineType);
		}
		
		this.lineType = lineType;
	}
}