package linePP.data;

import org.opencv.core.Point;

import linePP.helper.ImageProcessor;

public class Marginalia {
	private Segment segment;
	private Line correspondingLine;
	private java.awt.Point start;
	private java.awt.Point end;

	public Marginalia(Segment segment, Line correspondingLine) {
		setSegment(segment);
		setCorrespondingLine(correspondingLine);
	}

	private void update() {
		Point cog = ImageProcessor.calcCenterOfGravity(segment.getResizedRegion());
		setEnd(new java.awt.Point((int) cog.x, (int) cog.y));

		Point start = ImageProcessor.detectBottomRight(correspondingLine.getLinePoints());
		setStart(new java.awt.Point((int) start.x, (int) start.y));
	}

	public Segment getSegment() {
		return segment;
	}

	public void setSegment(Segment segment) {
		this.segment = segment;
	}

	public Line getCorrespondingLine() {
		return correspondingLine;
	}

	public void setCorrespondingLine(Line correspondingLine) {
		this.correspondingLine = correspondingLine;
		update();
	}

	public java.awt.Point getStart() {
		return start;
	}

	public void setStart(java.awt.Point start) {
		this.start = start;
	}

	public java.awt.Point getEnd() {
		return end;
	}

	public void setEnd(java.awt.Point end) {
		this.end = end;
	}
}