package linePP.drawing;

import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JDialog;
import javax.swing.JPanel;

import net.miginfocom.swing.MigLayout;

@SuppressWarnings("serial")
public class PopUp extends JDialog {
	private PopUp popUp;
	private Painter painter;

	private JButton btnSetHeading;
	private JButton btnCutAbove;
	private JButton btnCutBelow;
	private JComboBox<String> cobTypes;

	public PopUp(java.awt.Point point, Painter painter) {
		super();

		setPainter(painter);

		createWidgets();
		addWidgets();
		addListener();

		setPopUp(this);

		setModal(true);
		setLocation(point);
		setResizable(false);
		pack();
		setVisible(true);
	}

	private void addListener() {
		btnSetHeading.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				Cutter.performCut(painter.getPanel().getPage(), painter.getActiveSegment(),
						painter.getActiveLine(), true);
				popUp.dispose();
			}
		});
		
		btnCutAbove.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
//				Cutter.performCut(painter.getPanel().getPage(), painter.getActiveSegment(),
//						painter.getActiveLine().getOriginalLine(), false);
//				popUp.dispose();
			}
		});
		
		btnCutBelow.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				Cutter.performCut(painter.getPanel().getPage(), painter.getActiveSegment(),
						painter.getActiveLine(), false);
				popUp.dispose();
			}
		});

		cobTypes.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				Cutter.performCut(painter.getPanel().getPage(), painter.getActiveSegment(),
						painter.getActiveLine().getOriginalLine(), true);
				popUp.dispose();
			}
		});

//		btnAssignMarg.addActionListener(new ActionListener() {
//			public void actionPerformed(ActionEvent arg0) {
//				painter.setAssigningMarginalia(true);
//				Point start = ImageProcessor.detectBottomRight(painter.getActiveLine().getLinePoints());
//				painter.setStart(new java.awt.Point((int) start.x, (int) start.y));
//				popUp.dispose();
//			}
//		});
	}

	private void addWidgets() {
		MigLayout layout = new MigLayout();
		setLayout(layout);

		add(btnSetHeading, "sg 1, wrap");
		add(btnCutAbove, "sg 1, wrap");
		add(btnCutBelow, "sg 1, wrap");
//		add(btnAssignMarg, "sg 1, wrap");
		add(cobTypes, "sg 1");
	}

	private void createWidgets() {
		setContentPane(new JPanel());
		
		btnSetHeading = new JButton("Set Heading");

		
		btnCutAbove = new JButton("Cut Segment Above");
		btnCutAbove.setEnabled(false);
		btnCutBelow = new JButton("Cut Segment Below");
//		btnAssignMarg = new JButton("Assign To Marginalia");

//		if (!painter.getActiveLine().getType().equals(RegionType.paragraph)) {
//			btnAssignMarg.setEnabled(false);
//		}

//		String[] regionTypesString = RegionColors.getRegionsAssignedColors();
		String[] regionTypesString = {"heading"};
		

		cobTypes = new JComboBox<String>(regionTypesString) {
			@Override
			public Dimension getMaximumSize() {
				Dimension max = super.getMaximumSize();
				max.height = getPreferredSize().height;
				return max;
			}
		};
	}

	public PopUp getPopUp() {
		return popUp;
	}

	public void setPopUp(PopUp popUp) {
		this.popUp = popUp;
	}

	public Painter getPainter() {
		return painter;
	}

	public void setPainter(Painter painter) {
		this.painter = painter;
	}
}
