package program;

import java.awt.EventQueue;

import org.opencv.core.Core;

import gui.GuiInit;

public class BibSegmentation_Main {

	private static final boolean START_FROM_JAR = false;

	public static void main(String[] args) {
		org.apache.log4j.BasicConfigurator.configure();

		if (START_FROM_JAR) {
			loadLibrary();
		} else {
			System.loadLibrary("opencv_java249");
		}

		EventQueue.invokeLater(new Runnable() {
			public void run() {
				GuiInit gui = new GuiInit();
				gui.setVisible(true);
			}
		});
	}

	private static void loadLibrary() {
		String OS = System.getProperty("os.name").toLowerCase();
		int bitness = Integer.parseInt(System.getProperty("sun.arch.data.model"));

		if (OS.indexOf("win") >= 0) {
			if (bitness == 64) {
				System.loadLibrary("DLLs/OpenCV/[64bit]opencv_java249");
			} else if (bitness == 32) {
				System.loadLibrary("DLLs/OpenCV/[32bit]opencv_java249");
			}

			if (START_FROM_JAR) {
				if (bitness == 64) {
					System.loadLibrary("DLLs/Tess4J/64bit/gsdll64");
					System.out.println("gsdll64.dll successfully loaded!");

					System.loadLibrary("DLLs/Tess4J/64bit/msvcr120");
					System.loadLibrary("DLLs/Tess4J/64bit/liblept173");
					System.out.println("liblept170.dll successfully loaded!");

					System.loadLibrary("DLLs/Tess4J/64bit/msvcp120");
					System.loadLibrary("DLLs/Tess4J/64bit/libtesseract304");
					System.out.println("libtesseract303.dll successfully loaded!");

					//					 System.loadLibrary("DLLs/Tess4J/64bit/jnidispatch");
				} else {
					System.loadLibrary("DLLs/Tess4J/32bit/gsdll32");
					System.out.println("gsdll64.dll successfully loaded!");

					System.loadLibrary("DLLs/Tess4J/32bit/msvcr120");
					System.loadLibrary("DLLs/Tess4J/32bit/liblept173");
					System.out.println("liblept170.dll successfully loaded!");

					System.loadLibrary("DLLs/Tess4J/32bit/msvcp120");
					System.loadLibrary("DLLs/Tess4J/32bit/libtesseract304");
					System.out.println("libtesseract303.dll successfully loaded!");

					//					System.loadLibrary("DLLs/Tess4J/32bit/jnidispatch");
				}
			}
		} else {
			System.loadLibrary(Core.NATIVE_LIBRARY_NAME);
		}
	}
}